VERSION 5.00
Begin VB.Form frmCrazy8 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00008000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Crazy Eights"
   ClientHeight    =   6000
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   9000
   Icon            =   "FrmCrazy8.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   400
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   600
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdPass 
      Caption         =   "Pass (&Draw)"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4553
      TabIndex        =   1
      Top             =   3840
      Width           =   1095
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "&Play Card"
      Default         =   -1  'True
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   0
      Top             =   3840
      Width           =   1095
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New Game"
      End
      Begin VB.Menu mnuFileOptions 
         Caption         =   "&Options..."
      End
      Begin VB.Menu mnuFileScore 
         Caption         =   "&Score..."
      End
      Begin VB.Menu mnuFileBar 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpRules 
         Caption         =   "How to &Play..."
      End
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About Crazy Eights"
      End
   End
End
Attribute VB_Name = "frmCrazy8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Need to be able to slow down computer players a bit
Private Declare Function GetTickCount Lib "kernel32" () As Long
Dim lngTickStore As Long
Const DelayMS = 300                 'Delay 300ms between each player

Const NumPlayers = 4                'Standard 4 player game

Const Deck = 0                      'Constants used in determining which card belongs to what in the bytCard array
Const Player1 = 1
Const Player2 = 2
Const Player3 = 3
Const Player4 = 4
Const Discard = 5

Const DeckX = 260                   'Midpoints for all of the players and deck locations
Const DeckY = 200
Const DiscardX = 340
Const DiscardY = 200
Const Player1XMid = 300
Const Player1YMid = 335
Const Player2XMid = 50
Const Player2YMid = 200
Const Player3XMid = 300
Const Player3YMid = 65
Const Player4XMid = 550
Const Player4YMid = 200
Const CardOffsetX = 15
Const CardOffsetY = 15

Dim intPlayer1CardX As Integer      'What are the X and Y coordinates where each player's cards start to be placed?
Dim intPlayer1CardY As Integer
Dim intPlayer2CardX As Integer
Dim intPlayer2CardY As Integer
Dim intPlayer3CardX As Integer
Dim intPlayer3CardY As Integer
Dim intPlayer4CardX As Integer
Dim intPlayer4CardY As Integer

Dim intNumCards1 As Integer         'How many cards do the players currently have?
Dim intNumCards2 As Integer
Dim intNumCards3 As Integer
Dim intNumCards4 As Integer

Dim intGames As Integer             'How many games have been played so far?
Dim bytPlayerTurn As Byte           'Which player's turn is it?
Dim bytCurrentCard As Byte          'What is the value of the current card played?
Dim intDiscard As Integer           'Which card is currently on the discard pile?
Dim blnShowCards As Boolean         'Should we be showing the computer players' cards or not?
Dim blnGameOn As Boolean            'Is the game on, or not?

Dim cWidth As Long                  'Width of the standard cards from Cards32.DLL
Dim cHeight As Long                 'Height of the standard cards from Cards32.DLL
Dim bytCard(51) As Byte             'Describes the owner of each card in the deck
Dim bytInvert(51) As Byte           'Determines which card(s) are currently highlighted (inverted)
Dim BackFace As Integer             'What deck art are we using?

Private Sub Form_Load()

    'Initialize the card dll
    cdtInit cWidth, cHeight
    
    'Set the back of the card
    BackFace = ordPlaid
    
    'Set it to player 1's turn to start
    bytPlayerTurn = 1
    
    'No games have yet been played
    intGames = -1

    'Games go up to 100 to start
    intMaxScore = 100
    
    'Players start off with 5 cards
    intStartCards = 5
    
    'No game is active at startup
    blnGameOn = False

End Sub

Private Sub Form_Unload(Cancel As Integer)

    'Allow the card dll to terminate
    cdtTerm
    
    'End the game
    End

End Sub

Private Sub Deal()

Dim i As Integer
Dim j As Integer
Dim blnFoundCard
Dim intRndCard As Integer
    
    'Disable the "Options" menu function
    mnuFileOptions.Enabled = False
    
    'Hide the computer players' cards
    blnShowCards = False
    
    'Add one to the games total
    intGames = intGames + 1
    
    'Game on!
    blnGameOn = True
    
    'Replace all of the cards into the deck
    For i = 0 To UBound(bytCard)
        bytCard(i) = 0
    Next
    
    'Un-invert all cards
    For i = 0 To UBound(bytInvert)
        bytInvert(i) = 0
    Next
    
    'Set the initial number of cards for each player
    intNumCards1 = intStartCards
    intNumCards2 = intStartCards
    intNumCards3 = intStartCards
    intNumCards4 = intStartCards
    
    'Set the initial suit to "AnySuit"
    bytCurrentSuit = AnySuit
    
    'Set the initial card to "AnyCard"
    bytCurrentCard = AnyCard
    
    'Set the top visible discard card to nothing
    intDiscard = NoCard
    
    'Disable the buttons
    cmdPlay.Enabled = False
    cmdPass.Enabled = False
    
    'Step through each player
    For i = 1 To NumPlayers
        'Give each an appropriate number of random cards
        For j = 1 To intStartCards
            'Check if a random card is in the deck, if it is, give it to the player
            blnFoundCard = False
            Do While Not (blnFoundCard)
                'Reset the random number seed
                Randomize
                'Get a random card
                intRndCard = CInt(Rnd() * 51)
                'Check if it's in the deck
                If bytCard(intRndCard) = Deck Then
                    'Assign the card to the player
                    bytCard(intRndCard) = i
                    blnFoundCard = True
                End If
            Loop
        Next
    Next
    
    'Find out which player dealt, and give him his turn
    bytPlayerTurn = (intGames Mod NumPlayers) + 1
    TakeTurn bytPlayerTurn

End Sub

Private Sub Form_Paint()

Dim i As Integer
Dim blnDeckEmpty As Boolean
Dim strCaption As String

    'Clear the form
    Me.Cls

    'If there's no game, don't update
    If blnGameOn = False Then Exit Sub

    'Initialize our variable to check if the deck has any cards left in it
    blnDeckEmpty = True
    
    'Set the current player label
    strCaption = "Crazy Eights     (Player: " & bytPlayerTurn & ", Suit: "
    
    'Set the current suit label
    Select Case bytCurrentSuit
        Case Clubs
            strCaption = strCaption & "Clubs)"
        Case Diamonds
            strCaption = strCaption & "Diamonds)"
        Case Hearts
            strCaption = strCaption & "Hearts)"
        Case Spades
            strCaption = strCaption & "Spades)"
        Case AnySuit
            strCaption = strCaption & "Any)"
    End Select
    
    'Set the form's caption
    frmCrazy8.Caption = strCaption
    
    'Set up the starting X, Y for each player's cards
    intPlayer1CardX = Player1XMid - (cWidth + CardOffsetX * (intNumCards1 - 1)) / 2
    intPlayer1CardY = Player1YMid - (cHeight) / 2
    intPlayer3CardX = Player3XMid - (cWidth + CardOffsetX * (intNumCards3 - 1)) / 2
    intPlayer3CardY = Player3YMid - (cHeight) / 2
    intPlayer2CardX = Player2XMid - (cWidth) / 2
    intPlayer2CardY = Player2YMid - (cHeight + CardOffsetY * (intNumCards2 - 1)) / 2
    intPlayer4CardX = Player4XMid - (cWidth) / 2
    intPlayer4CardY = Player4YMid - (cHeight + CardOffsetY * (intNumCards4 - 1)) / 2
    
    'Step through each card and display it
    For i = 0 To UBound(bytCard)
        'Check if a card back should be displayed for the deck
        If bytCard(i) = 0 And blnDeckEmpty = True Then
            blnDeckEmpty = False
            cdtDraw Me.hdc, DeckX - (cWidth / 2), DeckY - (cHeight / 2), BackFace, ordBacks, vbWhite
        End If
        'Check which card is on the top of the discard
        If intDiscard <> NoCard Then
            cdtDraw Me.hdc, DiscardX - (cWidth / 2), DiscardY - (cHeight / 2), OrderSuits(intDiscard), ordFaces, vbWhite
        End If
        'If the card belongs to player1...
        If bytCard(i) = Player1 Then
            cdtDraw Me.hdc, intPlayer1CardX, intPlayer1CardY, OrderSuits(i), bytInvert(i), vbWhite
            intPlayer1CardX = intPlayer1CardX + CardOffsetX
        End If
        'If the card belongs to player2...
        If bytCard(i) = Player2 Then
            If blnShowCards = False Then cdtDraw Me.hdc, intPlayer2CardX, intPlayer2CardY, BackFace, ordBacks, vbWhite
            If blnShowCards = True Then cdtDraw Me.hdc, intPlayer2CardX, intPlayer2CardY, OrderSuits(i), ordFaces, vbWhite
            intPlayer2CardY = intPlayer2CardY + CardOffsetY
        End If
        'If the card belongs to player3...
        If bytCard(i) = Player3 Then
            If blnShowCards = False Then cdtDraw Me.hdc, intPlayer3CardX, intPlayer3CardY, BackFace, ordBacks, vbWhite
            If blnShowCards = True Then cdtDraw Me.hdc, intPlayer3CardX, intPlayer3CardY, OrderSuits(i), ordFaces, vbWhite
            intPlayer3CardX = intPlayer3CardX + CardOffsetX
        End If
        'If the card belongs to player4...
        If bytCard(i) = Player4 Then
            If blnShowCards = False Then cdtDraw Me.hdc, intPlayer4CardX, intPlayer4CardY, BackFace, ordBacks, vbWhite
            If blnShowCards = True Then cdtDraw Me.hdc, intPlayer4CardX, intPlayer4CardY, OrderSuits(i), ordFaces, vbWhite
            intPlayer4CardY = intPlayer4CardY + CardOffsetY
        End If
    Next
    
    'Let the form display
    DoEvents

End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim i As Integer
Dim intCard As Integer

    'Determine which card was selected and invert it
    
    'Set intCard = -1 (No card selected)
    intCard = -1
    
    'Set up the starting X, Y for each player's cards
    intPlayer1CardX = Player1XMid - (cWidth + CardOffsetX * (intNumCards1 - 1)) / 2
    intPlayer1CardY = Player1YMid - (cHeight) / 2
    intPlayer3CardX = Player3XMid - (cWidth + CardOffsetX * (intNumCards3 - 1)) / 2
    intPlayer3CardY = Player3YMid - (cHeight) / 2
    intPlayer2CardX = Player2XMid - (cWidth) / 2
    intPlayer2CardY = Player2YMid - (cHeight + CardOffsetY * (intNumCards2 - 1)) / 2
    intPlayer4CardX = Player4XMid - (cWidth) / 2
    intPlayer4CardY = Player4YMid - (cHeight + CardOffsetY * (intNumCards4 - 1)) / 2
    
    'Step through each card
    For i = 0 To UBound(bytCard)
        'Clear any previous inverts
        bytInvert(i) = ordFaces
        'If the card belongs to player1...
        If bytCard(i) = Player1 Then
            'check if it's been clicked
            If (X >= intPlayer1CardX) And (X <= intPlayer1CardX + cWidth) And (Y >= intPlayer1CardY) And (Y <= intPlayer1CardY + cHeight) Then intCard = i
            intPlayer1CardX = intPlayer1CardX + CardOffsetX
        End If
    Next
    
    'If a card was clicked and it's the first player's turn..
    If intCard <> -1 And bytPlayerTurn = Player1 Then
        'Invert the card
        bytInvert(intCard) = ordInvert
        'If the card is a valid card (for play) then enable the button
        If ValidPlay(intCard) Then
            cmdPlay.Enabled = True
        Else
            cmdPlay.Enabled = False
        End If
        'Redisplay
        Form_Paint
    'Otherwise, clear all inverted cards
    Else
        For i = 0 To UBound(bytInvert)
            bytInvert(i) = 0
        Next
        'Disable the play button
        cmdPlay.Enabled = False
        'Redisplay
        Form_Paint
    End If
    
End Sub

Private Function OrderSuits(intCardNum As Integer) As Integer

    'This function takes a card number and returns
    'a different one, effectively ordering all of
    'the cards according to suit

    If intCardNum >= 0 And intCardNum <= 12 Then OrderSuits = intCardNum * 4 + Clubs
    If intCardNum >= 13 And intCardNum <= 25 Then OrderSuits = ((intCardNum - 13) * 4) + Diamonds
    If intCardNum >= 26 And intCardNum <= 38 Then OrderSuits = ((intCardNum - 26) * 4) + Hearts
    If intCardNum >= 39 And intCardNum <= 51 Then OrderSuits = ((intCardNum - 39) * 4) + Spades

End Function

Private Function ValidPlay(intCard As Integer) As Boolean

    'Check if a given card is a valid play given the current game state
    
    'If any card at all can be played...
    If bytCurrentSuit = AnySuit Then
        ValidPlay = True
    'If the card selected is one of the eights...
    ElseIf intCard = 7 Or intCard = 20 Or intCard = 33 Or intCard = 46 Then
        ValidPlay = True
    'If the card is the right suit...
    ElseIf bytCurrentSuit = GetSuit(intCard) Then
        ValidPlay = True
    'If the card is the right value...
    ElseIf bytCurrentCard Mod 13 = intCard Mod 13 Then
        ValidPlay = True
    Else
        ValidPlay = False
    End If

End Function

Private Sub cmdPlay_Click()

Dim i As Integer

    'Find the selected card, and play it
    For i = 0 To UBound(bytInvert)
        If bytInvert(i) = ordInvert Then
            PlayCard i
            Exit Sub
        End If
    Next

End Sub

Private Sub PlayCard(intCard As Integer)

    'Place the indicated card on the discard stack, and
    'take any other appropriate action
    
    'Find the player who owns the card
    Select Case bytCard(intCard)
        Case Player1
            intNumCards1 = intNumCards1 - 1
        Case Player2
            intNumCards2 = intNumCards2 - 1
        Case Player3
            intNumCards3 = intNumCards3 - 1
        Case Player4
            intNumCards4 = intNumCards4 - 1
    End Select
    
    'Place the card on the discard pile
    bytCard(intCard) = Discard
    intDiscard = intCard
    
    'Repaint the screen
    Form_Paint
    
    'Check for victory conditions
    If (bytPlayerTurn = Player1 And intNumCards1 = 0) Or (bytPlayerTurn = Player2 And intNumCards2 = 0) Or (bytPlayerTurn = Player3 And intNumCards3 = 0) Or (bytPlayerTurn = Player4 And intNumCards4 = 0) Then
        'Show everyone's cards
        blnShowCards = True
        Form_Paint
        'Tell the player who won
        MsgBox "Player " & bytPlayerTurn & " wins this round.", vbOKOnly, "Round Over"
        'Add up the cards remaining in the losers' hands
        AddScores
        'Show the scores
        frmScore.Show vbModal, Me
        'If no one has won, deal the next hand
        If (intPlayer1Score >= intMaxScore) Or (intPlayer2Score >= intMaxScore) Or (intPlayer3Score >= intMaxScore) Or (intPlayer4Score >= intMaxScore) Then
            If (intPlayer1Score < intPlayer2Score) And (intPlayer1Score < intPlayer3Score) And (intPlayer1Score < intPlayer4Score) Then
                MsgBox "Player 1 wins the game!", vbOKOnly, "Winner!"
                ResetGame
            ElseIf (intPlayer2Score < intPlayer1Score) And (intPlayer2Score < intPlayer3Score) And (intPlayer2Score < intPlayer4Score) Then
                MsgBox "Player 2 wins the game!", vbOKOnly, "Winner!"
                ResetGame
            ElseIf (intPlayer3Score < intPlayer1Score) And (intPlayer3Score < intPlayer2Score) And (intPlayer3Score < intPlayer4Score) Then
                MsgBox "Player 3 wins the game!", vbOKOnly, "Winner!"
                ResetGame
            ElseIf (intPlayer4Score < intPlayer1Score) And (intPlayer4Score < intPlayer2Score) And (intPlayer4Score < intPlayer3Score) Then
                MsgBox "Player 4 wins the game!", vbOKOnly, "Winner!"
                ResetGame
            Else
                MsgBox "We have a tie! Play another round.", vbOKOnly, "Tie!"
                Deal
            End If
        Else
            Deal
        End If
        Exit Sub
    End If
    
    'Set the current card data
    bytCurrentCard = intCard
    bytCurrentSuit = GetSuit(intCard)
    
    'If it was an eight...
    If intCard = 7 Or intCard = 20 Or intCard = 33 Or intCard = 46 Then
        'If a computer player played it...
        If bytPlayerTurn <> Player1 Then
            'Find a random suit to change to
            Randomize
            bytCurrentSuit = CInt(Rnd() * 3)
            'Inform the user that the suit has changed
            Select Case bytCurrentSuit
                Case Clubs
                    MsgBox "An Eight has been played, suit is now Clubs.", vbOKOnly, "Suit Change"
                Case Diamonds
                    MsgBox "An Eight has been played, suit is now Diamonds.", vbOKOnly, "Suit Change"
                Case Hearts
                    MsgBox "An Eight has been played, suit is now Hearts.", vbOKOnly, "Suit Change"
                Case Spades
                    MsgBox "An Eight has been played, suit is now Spades.", vbOKOnly, "Suit Change"
            End Select
        'If player1 played it...
        Else
            'Make him select a new suit
            frmNominate.Show vbModal, Me
        End If
    End If
    
    'Un-invert the card
    bytInvert(intCard) = 0
    
    'Increment turns
    If bytPlayerTurn < NumPlayers Then
        bytPlayerTurn = bytPlayerTurn + 1
    Else
        bytPlayerTurn = Player1
    End If
    TakeTurn bytPlayerTurn

End Sub

Private Function GetSuit(intCard As Integer) As Byte

    'Find and return the suit of a given card
    If (intCard >= 0 And intCard <= 12) Then GetSuit = Clubs
    If (intCard >= 13 And intCard <= 25) Then GetSuit = Diamonds
    If (intCard >= 26 And intCard <= 38) Then GetSuit = Hearts
    If (intCard >= 39 And intCard <= 51) Then GetSuit = Spades

End Function

Private Sub TakeTurn(bytPlayer As Byte)

Dim i As Integer
Dim blnPlayedCard As Boolean

    'Make the appropriate player take his turn
    
    'Uninvert all cards and disable "Play" button
    cmdPlay.Enabled = False
    For i = 0 To UBound(bytInvert)
        bytInvert(i) = 0
    Next
    
    'repaint
    Form_Paint
    
    'If it's player 1's turn, enable the "Pass" button
    'Otherwise, disable it
    If bytPlayer = Player1 Then
        cmdPass.Enabled = True
    Else
        cmdPass.Enabled = False
    End If
    
    'If it's not player 1's turn, make the appropriate
    'computer player play a card
    blnPlayedCard = False
    If bytPlayerTurn <> Player1 Then
        'Pause for a bit
        SlowDown
        'Scan through the player's cards
        For i = 0 To UBound(bytCard)
            'Check if any cards are playable
            If bytCard(i) = bytPlayerTurn And ValidPlay(i) Then
                PlayCard i
                blnPlayedCard = True
                Exit For
            End If
        Next
        'If no cards were playable, pass
        If blnPlayedCard = False Then PassTurn bytPlayerTurn
    End If

End Sub

Private Sub cmdPass_Click()

    'The player has passed his turn
    PassTurn Player1

End Sub

Private Sub PassTurn(bytPlayer As Byte)

Dim i As Integer
Dim blnFoundCard As Boolean
Dim intRndCard As Integer

    'If a player elects to pass, give him an extra card
    Select Case bytPlayer
        Case Player1
            intNumCards1 = intNumCards1 + 1
        Case Player2
            intNumCards2 = intNumCards2 + 1
        Case Player3
            intNumCards3 = intNumCards3 + 1
        Case Player4
            intNumCards4 = intNumCards4 + 1
    End Select
    
    'Check if there are still cards in the deck
    blnFoundCard = False
    For i = 0 To UBound(bytCard)
        If bytCard(i) = Deck Then
            blnFoundCard = True
            Exit For
        End If
    Next
    'If the deck is empty, replenish it, but leave
    'the top card of the discard pile
    If blnFoundCard = False Then
        For i = 0 To UBound(bytCard)
            If bytCard(i) = Discard And bytCard(i) <> intDiscard Then
                bytCard(i) = Deck
            End If
        Next
    End If
    
    'Find a random card to give
    blnFoundCard = False
    Do While Not (blnFoundCard)
        'Reset the random number seed
        Randomize
        'Get a random card
        intRndCard = CInt(Rnd() * 51)
        'Check if it's in the deck
        If bytCard(intRndCard) = Deck Then
            'Assign the card to the player
            bytCard(intRndCard) = bytPlayer
            blnFoundCard = True
        End If
    Loop
    
    'Repaint
    Form_Paint
    
    'Increment turns
    If bytPlayerTurn < NumPlayers Then
        bytPlayerTurn = bytPlayerTurn + 1
    Else
        bytPlayerTurn = Player1
    End If
    TakeTurn bytPlayerTurn

End Sub

Private Sub AddScores()

Dim i As Integer

    'Add up the values of the cards left in losers' hands
    For i = 0 To UBound(bytCard)
        Select Case bytCard(i)
            Case Player1
                intPlayer1Score = intPlayer1Score + ValueCard(i)
            Case Player2
                intPlayer2Score = intPlayer2Score + ValueCard(i)
            Case Player3
                intPlayer3Score = intPlayer3Score + ValueCard(i)
            Case Player4
                intPlayer4Score = intPlayer4Score + ValueCard(i)
        End Select
    Next

End Sub

Private Function ValueCard(intCard As Integer)

    'Returns the point value of a card
    
    'Eights are worth fifty
    If intCard = 7 Or intCard = 20 Or intCard = 33 Or intCard = 46 Then
        ValueCard = 50
        Exit Function
    End If
    
    'Faces are worth 10
    If intCard Mod 13 > 9 Then
        ValueCard = 10
        Exit Function
    End If
    
    'All others are worth face value
    ValueCard = (intCard Mod 13) + 1

End Function

Private Sub ResetGame()

    'Reset the game data
    mnuFileOptions.Enabled = True
    Me.Caption = "Crazy Eights"
    cmdPlay.Enabled = False
    cmdPass.Enabled = False
    intPlayer1Score = 0
    intPlayer2Score = 0
    intPlayer3Score = 0
    intPlayer4Score = 0
    blnGameOn = False       'Game is over
    Me.Cls

End Sub

Private Sub mnuFileOptions_Click()

    'Show the options form
    frmOptions.Show vbModal, Me

End Sub

Private Sub mnuHelpAbout_Click()

    'Show the frmAbout
    frmAbout.Show vbModal, Me

End Sub

Private Sub mnuFileExit_Click()

    'Exit the game
    Unload Me

End Sub

Private Sub mnuFileNew_Click()

    'Reset and start again
    ResetGame
    Deal

End Sub

Private Sub mnuFileScore_Click()

    'Show the score
    frmScore.Show vbModal, Me

End Sub

Private Sub SlowDown()

    'Delay the effect somewhat
    lngTickStore = GetTickCount()
    Do While lngTickStore + DelayMS > GetTickCount()
        DoEvents
    Loop

End Sub

Private Sub mnuHelpRules_Click()

    'Show the rules form
    frmHelp.Show vbModal, Me

End Sub
